Skip to main content

Trie - Question 2

 Leetcode 211. Design Add and Search Words Data Structure

Design a data structure that supports adding new words and finding if a string matches any previously added string.

Implement the WordDictionary class:

WordDictionary() Initializes the object.

void addWord(word) Adds word to the data structure, it can be matched later.

bool search(word) Returns true if there is any string in the data structure that matches word or false otherwise. word may contain dots '.' where dots can be matched with any letter.

Constraints:

1 <= word.length <= 500

word in addWord consists lower-case English letters.

word in search consist of  '.' or lower-case English letters.

At most 50000 calls will be made to addWord and search.


Analysis:

This question asks to build a word dictionary, which essentially a trie.

So we can define a node structure which has 26 children and a Boolean to label whether a string (or prefix) a word or not.

With this node structure, we can build a trie containing all the words. For each letter in the word, we move down one layer in the trie.

After building the trie, we can do the search, to determine whether a string is in the trie or not. Since the input string has wildcard (*), so recursive solution becomes suitable. The key to recursive solution is: the same question but a smaller size.


See the code below:


class WordDictionary {
struct node {
    vector<node*> nds;
    bool isW;
    node() {
        nds.resize(26);
        isW = false;
    }
};
public:
    /** Initialize your data structure here. */
    WordDictionary() {
        root = new node();
    }
    
    void addWord(string word) {
        node* p = root;
        for(auto &a : word) {
            int id = a - 'a';
            if(!p->nds[id]) p->nds[id] = new node();
            p = p->nds[id];
        }
        p->isW = true;
    }
    
    bool search(string word) {
        return isV(root, word);
    }
private:
    node* root;
    bool isV(node* p, string word) {
        if(word.empty()) return p->isW;
        if(word[0] != '.') {
            int id = word[0] - 'a';
            if(!p->nds[id]) return false;
            return isV(p->nds[id], word.substr(1));
        }
        for(auto &a : p->nds) {
            if(a && isV(a, word.substr(1))) return true;
        }
        return false;
    }
};

/**
 * Your WordDictionary object will be instantiated and called as such:
 * WordDictionary* obj = new WordDictionary();
 * obj->addWord(word);
 * bool param_2 = obj->search(word);
 */


Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...